/*
 * Copyright (c) 2013, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package animations;

import javafx.animation.Interpolator;
import javafx.animation.TranslateTransition;
import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;
import javafx.util.Duration;

/** User: rbair Date: 5/31/13 Time: 2:06 PM */
public class TranslatedRectangle extends Application {

    @Override public void start(Stage primaryStage) throws Exception {
        Rectangle r = new Rectangle(100, 100);
        Group root = new Group(r);
        Scene scene = new Scene(root, 800, 600);
        primaryStage.setScene(scene);
        primaryStage.show();

        TranslateTransition tx = new TranslateTransition(Duration.seconds(5), r);
        tx.setInterpolator(Interpolator.LINEAR); // So as to make any Jitter obvious
        tx.setFromX(0);
        tx.setFromY(250);
        tx.setToX(700);
        tx.setToY(250);
        tx.setCycleCount(TranslateTransition.INDEFINITE);
        tx.setAutoReverse(true);
        tx.play();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
