/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.stage;

/**
Builder class for javafx.stage.FileChooser
@see javafx.stage.FileChooser
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public final class FileChooserBuilder implements javafx.util.Builder<javafx.stage.FileChooser> {
    protected FileChooserBuilder() {
    }

    /** Creates a new instance of FileChooserBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.stage.FileChooserBuilder create() {
        return new javafx.stage.FileChooserBuilder();
    }

    private int __set;
    public void applyTo(javafx.stage.FileChooser x) {
        int set = __set;
        if ((set & (1 << 0)) != 0) x.getExtensionFilters().addAll(this.extensionFilters);
        if ((set & (1 << 1)) != 0) x.setInitialDirectory(this.initialDirectory);
        if ((set & (1 << 2)) != 0) x.setTitle(this.title);
    }

    private java.util.Collection<? extends javafx.stage.FileChooser.ExtensionFilter> extensionFilters;
    /**
    Add the given items to the List of items in the {@link javafx.stage.FileChooser#getExtensionFilters() extensionFilters} property for the instance constructed by this builder.
    */
    public javafx.stage.FileChooserBuilder extensionFilters(java.util.Collection<? extends javafx.stage.FileChooser.ExtensionFilter> x) {
        this.extensionFilters = x;
        __set |= 1 << 0;
        return this;
    }

    /**
    Add the given items to the List of items in the {@link javafx.stage.FileChooser#getExtensionFilters() extensionFilters} property for the instance constructed by this builder.
    */
    public javafx.stage.FileChooserBuilder extensionFilters(javafx.stage.FileChooser.ExtensionFilter... x) {
        return extensionFilters(java.util.Arrays.asList(x));
    }

    private java.io.File initialDirectory;
    /**
    Set the value of the {@link javafx.stage.FileChooser#getInitialDirectory() initialDirectory} property for the instance constructed by this builder.
    */
    public javafx.stage.FileChooserBuilder initialDirectory(java.io.File x) {
        this.initialDirectory = x;
        __set |= 1 << 1;
        return this;
    }

    private java.lang.String title;
    /**
    Set the value of the {@link javafx.stage.FileChooser#getTitle() title} property for the instance constructed by this builder.
    */
    public javafx.stage.FileChooserBuilder title(java.lang.String x) {
        this.title = x;
        __set |= 1 << 2;
        return this;
    }

    /**
    Make an instance of {@link javafx.stage.FileChooser} based on the properties set on this builder.
    */
    public javafx.stage.FileChooser build() {
        javafx.stage.FileChooser x = new javafx.stage.FileChooser();
        applyTo(x);
        return x;
    }
}
